(*	$Id: LibSummary.Mod,v 1.1 1997/02/07 07:45:32 oberon1 Exp $	*)
MODULE LibSummary;  <* Warnings := FALSE *>
(* Note: To compile the modules with oo2c you have to adjust the local 
   configuration file oo2crc to your system and tell oo2c to use it by setting
   the option `--config oo2crc'.  *)
   
IMPORT
  (* basic string handling *)
  Ascii,            (* standard short character names for control chars *)
  CharClass,        (* classification of values of type CHAR *)
  Strings,          (* facilities to manipulate strings *)
  
  (* integer/string conversion *)
  ConvTypes,        (* common types used in the string conversion modules *)
  IntConv,          (* low-level integer/string conversions *)
  IntStr,           (* integer-number/string conversions *)
  
  (* I/O subsystem *)  
  Channel,          (* defines abtract channel type *)
  StdChannels,      (* interface to standard in, out, and err channels *)
  Files,            (* file access *)
  ProgramArgs,      (* facilities to access program arguments *)
  TextRider,        (* textual input from and output to the above channels *)
  BinaryRider,      (* binary input from and output to the above channels *)
  In,               (* simple interface to standard input *)
  Out,              (* simple interface to standard output *)
  Err,              (* simple interface to standard error channel *)
  
  (* math libs, real/string conversion *)
  LowReal,          (* access to underlying properties of type REAL *)
  RealMath,         (* mathematical functions for REAL *)
  RealConv,         (* low-level REAL/string conversions *)
  RealStr,          (* REAL/string conversions *)
  
  LowLReal,         (* access to underlying properties of type LONGREAL *)
  LRealMath,        (* mathematical functions for LONGREAL *)
  LRealConv,        (* low-level LONGREAL/string conversions *)
  LRealStr,         (* LONGREAL/string conversions *)
  
  (* complex math (note: OOC will include complex types in the future; these
     libs will be changed to operate on the builtin types *)
  ComplexMath,      (* mathematical functions for type COMPLEX *)
  LComplexMath,     (* mathematical functions for type LONGCOMPLEX *)
  
  (* time stamps and intervalls, conversion between string and time *)
  Time,             (* manipulation of time stamps and time intervalls *)
  Calendar,         (* conversion between time stamp and calendar/clock *)
  SysClock,         (* reading and setting the system clock *)

  (* random number generator *)
  RandomNumbers,    (* preliminary version *)

  (* Oakwood compliant modules *)
  OakIn,            (* basic functions for formatted input *)
  OakOut,           (* basic functions for formatted output *)
  OakMath,          (* mathematical functions for REAL *)
  OakMathL;         (* mathematical functions for LONGREAL *)
  

(* 
There are a number of modules that were used in this implementation, but 
that aren't part of the OOC library (yet).  These modules are not guaranteed 
to be available on all systems:

  o PosixFileDescr
  o JulianDay
  o Integers
  o LongInts
*)

END LibSummary.
