/*	$Id: __oo2c.c,v 1.1 1997/02/07 07:46:48 oberon1 Exp $	*/
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include "__oo2c.h"

char* _top_vs;  /* top of value stack */
char* _end_vs;  /* end of value stack */

LONGINT _program_argc;
CHAR **_program_argv;
INTEGER _program_exit_code = 0;


/* --- initialization function, called at the beginning of main(): */
void _oo2c__init(void) {
/* if you have installed gc as a SunOS 5 dynamic lib, include gc.h 
   and uncomment GC_INIT()  */
/*  GC_INIT(); */  
}



/* --- functions to report failed runtime checks: */
#define POS_MODULO 1024
#define PREFIX "## "

static void print_header(const char msg[], LONGINT pos) {
  _Module m;
  const char* mname;
  
  m = _get_module (pos % POS_MODULO);
  if (m) {
    mname = (const char*)m->name;
  } else { 
    mname = "<\?\?\?>";
  }
  fprintf(stderr, PREFIX "\n" 
	          PREFIX "%s failed in module %s at pos " LI_FORMAT ":\n" PREFIX,
	  msg, mname, pos / POS_MODULO);
}
  
static void print_header2(LONGINT pos) {
  _Module m;
  const char* mname;
  
  m = _get_module (pos % POS_MODULO);
  if (m) {
    mname = (const char*)m->name;
  } else { 
    mname = "<\?\?\?>";
  }
  (void)fprintf(stderr, PREFIX "\n" 
		PREFIX "Error in module %s at pos " LI_FORMAT ":\n" PREFIX, 
		mname, pos / POS_MODULO);
}

static void NORETURN _break_rtc(void) NORETURN2;

static void _break_rtc(void) {
/* use this function as breakpoint when debugging a failed runtime check */
  exit(1);
}


void _deref_of_nil(LONGINT pos) {
  print_header2(pos);
  (void)fprintf(stderr, "Dereference of NIL\n" PREFIX "\n");
  _break_rtc();
}

void _div_by_zero(LONGINT pos) {
  print_header2(pos);
  (void)fprintf(stderr, "Division by zero\n" PREFIX "\n");
  _break_rtc();
}

void _index_out_of_range(LONGINT index, LONGINT length, LONGINT pos) {
  print_header("Index check", pos);
  (void)fprintf(stderr, LI_FORMAT " not in 0 <= x < " LI_FORMAT "\n" PREFIX 
		"\n", index, length);
  _break_rtc();
}

void _element_out_of_range(LONGINT index, LONGINT size, LONGINT pos) {
  print_header("Set element check", pos);
  (void)fprintf(stderr, LI_FORMAT " not in 0 <= x < " LI_FORMAT "\n" PREFIX 
		"\n", index, size);
  _break_rtc();
}

void _no_return(LONGINT pos) {
  print_header2(pos);
  (void)fprintf(stderr, "Control reaches end of function procedure\n" PREFIX 
		"\n");
  _break_rtc();
}

void _case_failed(LONGINT select, LONGINT pos) {
  print_header2(pos);
  (void)fprintf(stderr, "Invalid CASE selector.  `" LI_FORMAT 
		"' doesn't match any label.\n" PREFIX "\n", select);
  _break_rtc();
}

void _with_failed(LONGINT pos) {
  print_header2(pos);
  (void)fprintf(stderr, "All guards of WITH statement failed.\n" PREFIX "\n");
  _break_rtc();
}

void _type_guard_failed(void* tag, LONGINT pos) {
  const CHAR *tname = ((_Type)tag)->name;
  const CHAR *mname = ((_Type)tag)->module->name;

  print_header2(pos);
  if (!tname) tname = (const CHAR*)"<unknown>";
  (void)fprintf(stderr, "Type guard failed.\n" PREFIX
		"The variable's dynamic type is %s.%s\n" PREFIX "\n", 
		mname, tname);
  _break_rtc();
}

void _type_assert_failed(LONGINT pos) {
  print_header2(pos);
  (void)fprintf(stderr, "Dynamic type differs from static type.\n" PREFIX "\n");
  _break_rtc();
}

void _assertion_failed(LONGINT code, LONGINT pos) {
  print_header2(pos);
  (void)fprintf(stderr, "Assertion failed, exit code " LI_FORMAT "\n" PREFIX 
		"\n", code);
  _break_rtc();
}

void _halt(LONGINT code){
  exit(code);
}

void _array_stack_overflow(void) {
  fprintf(stderr, PREFIX "\n" 
	          PREFIX "Overflow of array stack\n" PREFIX "\n");
  _break_rtc();
}


#include "__Descr.c"
